Attribute VB_Name = "Windows"
'Konstante fr "GetWindow"
Const GW_HWNDFIRST = 0
Const GW_HWNDNEXT = 2

'Konstante fr "GetWindowLong"
Const GWL_STYLE = (-16)

'Konstante fr "IsTask"
Const WIN_VISIBLE = &H10000000
Const WIN_BORDER = &H800000

'Konstante fr "SetWindowPos"
Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2

'Typ fr "GetWindowRect"
Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Declare Function GetWindowText Lib "user32" _
  Alias "GetWindowTextA" _
  (ByVal hwnd As Long, _
  ByVal lpString As String, _
  ByVal cch As Long) As Long

Declare Function GetWindow Lib "user32" _
  (ByVal hwnd As Long, _
  ByVal wCmd As Long) As Long

Declare Function GetWindowLong Lib "user32" _
  Alias "GetWindowLongA" _
  (ByVal hwnd As Long, _
  ByVal wIndx As Long) As Long

Declare Function GetWindowTextLength Lib "user32" _
  Alias "GetWindowTextLengthA" _
  (ByVal hwnd As Long) As Long

Declare Function GetParent Lib "user32" _
  (ByVal hwnd As Long) As Long

Declare Function FindWindow Lib "user32" _
  Alias "FindWindowA" _
  (ByVal lpClassName As String, _
  ByVal lpWindowName As String) As Long

Declare Function GetWindowRect Lib "user32" _
  (ByVal hwnd As Long, _
  lpRect As RECT) As Long
  
Declare Function SetWindowPos Lib "user32" _
  (ByVal hwnd As Long, _
  ByVal hWndInsertAfter As Long, _
  ByVal x As Long, ByVal y As Long, _
  ByVal cx As Long, ByVal cy As Long, _
  ByVal wFlags As Long) As Long
  
Declare Function IsIconic Lib "user32" _
  (ByVal hwnd As Long) As Long

Declare Function GetForegroundWindow Lib "user32" _
  () As Long

Declare Function SetActiveWindow Lib "user32" _
  (ByVal hwnd As Long) As Long
  
Declare Function SetForegroundWindow Lib "user32" _
  (ByVal hwnd As Long) As Long

Dim IsTask As Long

Public Sub GetAllParentWindows(ByRef ArrayName() As String, SourceForm, _
  Optional ByVal SearchFor As String)

  Dim Count As Integer
  Dim Fore As Long
  Dim hwCurr As Long
  Dim intLen As Long
  Dim strTitle As String
  Dim TitleMatches As Boolean
  Dim isTop As Boolean
  Static State As Boolean
  
  Erase ArrayName
  ReDim Preserve ArrayName(0)
  hwCurr = GetWindow(SourceForm.hwnd, GW_HWNDFIRST)
  
  Fore = GetForegroundWindow
           
  IsTask = WIN_VISIBLE Or WIN_BORDER
  Do While hwCurr
    If hwCurr <> SourceForm.hwnd And TaskWindow(hwCurr) Then
      intLen = GetWindowTextLength(hwCurr) + 1
      strTitle = Space$(intLen)
      intLen = GetWindowText(hwCurr, strTitle, intLen)
      If SearchFor <> "" Then
        TitleMatches = (InStr(UCase$(strTitle), UCase$(SearchFor)) <> 0)
      Else
        TitleMatches = True
      End If
      If intLen > 0 And TitleMatches Then
        If GetParent(hwCurr) = 0 Then
          ArrayName(UBound(ArrayName)) = strTitle
          ReDim Preserve ArrayName(UBound(ArrayName) + 1)
          If Not IsIconic(hwCurr) Then Count = Count + 1
          If Fore = hwCurr Then isTop = True
        End If
      End If
    End If
    hwCurr = GetWindow(hwCurr, GW_HWNDNEXT)
  Loop
  If UBound(ArrayName) > 0 Then
    ReDim Preserve ArrayName(UBound(ArrayName) - 1)
  End If
  
  If Count <> 0 Then
    If Not Main.Visible Then
      Main.Visible = True
      SetForegroundWindow (Main.hwnd)
    End If
    If isTop Then
      If State = False Then
      SetWindowPos Main.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
        State = True
      End If
      State = True
    Else
      If State = True Then SetWindowPos Main.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
      State = False
    End If
  Else
    Main.Visible = False
  End If
  
  SetForegroundWindow (Fore)
  SetActiveWindow (Fore)

End Sub

Public Function GetWindowTitle(SearchFor As String, SourceForm) As String

  Dim hwCurr As Long
  Dim intLen As Long
  Dim strTitle As String
  
  hwCurr = GetWindow(SourceForm.hwnd, GW_HWNDFIRST)
  
  IsTask = WIN_VISIBLE Or WIN_BORDER
  Do While hwCurr
    If hwCurr <> SourceForm.hwnd And TaskWindow(hwCurr) Then
      intLen = GetWindowTextLength(hwCurr) + 1
      strTitle = Space$(intLen)
      intLen = GetWindowText(hwCurr, strTitle, intLen)
      If intLen > 0 And InStr(UCase(strTitle), UCase(SearchFor)) Then
        GetWindowTitle = strTitle
        Exit Function
      End If
    End If
    hwCurr = GetWindow(hwCurr, GW_HWNDNEXT)
  Loop
  GetWindowTitle = ""
  
End Function

Public Function GetWindowHandle(SearchFor As String, SourceForm) As Long

  Dim hwCurr As Long
  Dim intLen As Long
  Dim strTitle As String
  
  hwCurr = GetWindow(SourceForm.hwnd, GW_HWNDFIRST)
  
  IsTask = WIN_VISIBLE Or WIN_BORDER
  Do While hwCurr
    If hwCurr <> SourceForm.hwnd And TaskWindow(hwCurr) Then
      intLen = GetWindowTextLength(hwCurr) + 1
      strTitle = Space$(intLen)
      intLen = GetWindowText(hwCurr, strTitle, intLen)
      If intLen > 0 And InStr(UCase(strTitle), UCase(SearchFor)) Then
        GetWindowHandle = hwCurr
        Exit Function
      End If
    End If
    hwCurr = GetWindow(hwCurr, GW_HWNDNEXT)
  Loop
  GetWindowHandle = &H0&
  
End Function

Private Function TaskWindow(hwCurr As Long) As Long

  Dim lngStyle As Long
  
  lngStyle = GetWindowLong(hwCurr, GWL_STYLE)
  If (lngStyle And IsTask) = IsTask Then TaskWindow = True
  
End Function
